<template>

    <div class="form justify-center q-gutter-md" v-if="$coreAuth.user == null">
        <q-banner v-for="(e,i) in errs" :key="i" dense class="bg-red text-white">
            <template v-slot:avatar>
                <q-icon name="icofont-warning"/>
            </template>
            {{ e }}
        </q-banner>
        <q-input v-for="i in fields" :error-message="errors[i.key]"
                 :key="i.key"
                 v-model="models[i.key]"
                 :rules="i.rules"
                 :ref="i.key"
                 :error="hasError[i.key]"
                 label-slot
                 filled
                 @input="OnType">
            <template v-slot:label>
                <LabelSlot :icon="i.icon" :label="i.label"
                           :tooltip="i.tooltip"/>
            </template>
            <template v-slot:counter v-if="i.max!= null">
                {{ models[i.key].length }}/{{ i.max }}
            </template>

        </q-input>
    </div>

</template>

<style lang='scss' scoped>

</style>

<script lang='ts'>
import {Component, Vue} from 'vue-property-decorator';
import LabelSlot from "components/LabelSlot.vue";
import {Input} from "src/classLibrary/Input";
import {ApiError} from "src/classLibrary/Core/Api";
import {ApplyValidation} from "src/classLibrary/Utility";
import {goodOnes} from "boot/assets";
import {UserPrincipalResponse} from "src/classLibrary/APIModels/core/userPrincipalResponse";


@Component({
    components: {LabelSlot}
})
export default class SetupProfile extends Vue {
    errors: { [s: string]: string | null } = {
        username: '',
        name: '',
    }

    errs: string[] = []

    hasError: { [s: string]: boolean } = {
        username: false,
        name: false,
    }
    models: { [s: string]: string } = {
        username: '',
        name: ''
    }

    fields: Input[] = [
        {
            key: 'username',
            rules: [
                (v: string) => !!v || 'Please enter your username',
                (v: string) => v.match(/^[0-9a-zA-Z\-_]*$/) || 'Username must be can be alpha-numeric, and contain - or _',
                (v: string) => (v.length < 11 && v.length > 2) || 'Username can only have 3 to 10 characters',
            ],
            label: 'Username',
            tooltip: "For colleagues to search and add your account. Between 3 to 10 alphanumeric, - and _ characters",
            icon: 'icofont-at',
            max: 10,
        },
        {
            key: 'name',
            rules: [
                (v: string) => !!v || 'Please enter your name',
                (v: string) => (v.length < 129 && v.length > 1) || 'Name can only have 2 to 128 characters',
            ],
            label: 'Name',
            tooltip: "Full name, for other users to identify your account",
            icon: 'icofont-ui-v-card',
            max: 128,
        }
    ]

    OnType() {
        for (let k in this.hasError) {
            this.hasError[k] = false
        }
    }

    async Submit() {
        this.fields.Map(x => !(this.$refs[x.key] as any)
            .Each((x: any) => x.validate()));
        const valid = this.fields.All(x => !(this.$refs[x.key] as any)[0].hasError)

        if (!valid) return;
        const token = await this.$auth.CoreToken;
        const r = await this.$coreApi.Post<UserPrincipalResponse>('User/register', {
            sub: this.$auth.user?.sub,
            username: this.models.username,
            name: this.models.name,
            email: this.$auth.user?.email,
            materialBackground: goodOnes.Random()
        }, token);

        let errs: string[] = [];

        const parent = this;
        r.match({
            ok: () => {
                parent.$coreAuth.Registered();
            },
            err: e => ApiError.match(e, {
                Object: (o) => {
                    errs = ApplyValidation(parent.errors, parent.hasError, o)
                },
                String: (o) => {
                    errs = [o.error]
                },
                Null: (o) => {
                    if (o?.error) {
                        const e: string = o.error;
                        errs = [e]
                    }
                },
                default: (_v) => console.error(_v),
            })
        })
        this.errs = errs;
    }


}
</script>
